﻿using System;
using System.Reflection;
using SlatedGameToolkit.Tools.Commands;
using SlatedGameToolkit.Tools.System;
using SlatedGameToolkit.Tools.System.Interaction;

namespace SlatedGameToolkit.Tools
{
    class ConsoleProgram
    {
        static private bool running;
        static void Main(string[] args)
        {
            CommandMap commands = new CommandMap(new StopCommand());
            commands.Add(new HelpCommand(commands));
            CommandProcessor processor = new CommandProcessor("The command \"{input}\" was not understood. Please type \"help\" for more information.", commands);
            AssemblyName name = Assembly.GetExecutingAssembly().GetName();
            ConsoleInteraction consoleInteracter = new ConsoleInteraction("Tools");
            consoleInteracter.Tell(String.Format("{0} Version: {1}", name.Name, name.Version));
            consoleInteracter.Tell("Welcome to SlatedGameToolkit.Tools! These tools are meant for the developers using the SlatedGameToolkit. Type \"help\" for a list of things this tool can currently do.");
            running = true;
            while (running) {
                consoleInteracter.Separate();
                processor.Process(consoleInteracter);
            }
            consoleInteracter.Tell("Exiting tool.");
        }

        public static void Stop() {
            running = false;
        }
    }
}
